# (c) Hochschule Anhalt, veröffentlicht unter MIT-Lizenz
# Geist-Klasse
# Autor: Viktor Lysow, Johannes Tümler
# Letzte Änderung: 18.03.2024
# Zweck: Geist-Entität definieren
#
# Geist erbt alles von Monster
# können den Held bei Berührung töten
# Geist kann neue Monster erschaffen, die wie Geister aussehen (Duplizieren)

# Der Nachfolgende Codeblock "BLOCK1" sorgt dafür, dass man aus jeder Datei heraus das Hauptprogramm starten kann.
# Dadurch kann man in jeder Datei auf "play" drücken und es wird automatisch main.py gestartet.
if __name__=="__main__":
    import subprocess
    # Auf Linux oder Mac aktivieren Sie die folgende Zeile und deaktivieren Sie die Zeile danach:
    #subprocess.call("python3 main.py", shell=True)  # die richtige Main-Datei aufrufen (unser eigentliches Hauptprogramm)
    subprocess.call("main.py", shell=True)  # die richtige Main-Datei aufrufen (unser eigentliches Hauptprogramm)
    exit(0) # nun das Programm hier beenden .. wir wollen ja nur das Hauptprogramm starten und nicht *diese* Datei.
    # Hinweis fürs Debugging: Das VSCode-Debugging funktioniert jedoch nur, wenn man das Debugging in der "main.py" beginnt! D.h. wer debuggen möchte, muss die main.py öffnen und dort Debug starten.
# Ende "BLOCK1"

import pygame
from KlasseMonster import Monster
from time import time
from random import randint

class Geist (Monster):
                                                              #Liste der erschaffenen Monster
    def __init__(self, x, y, geschw, breite, hoehe, level, bildFigur, zeitMonster):
        super().__init__(x, y, geschw, breite, hoehe, level, bildFigur, zeitMonster)

        self.zeitUnsicht = zeitMonster
        self.bildUnsicht = [pygame.image.load("Bilder/Geist/tot.png"),
                         pygame.image.load("Bilder/Geist/tot.png")]
        self.saveBildOben = self.bildOben
        self.saveBildUnten = self.bildUnten
        self.saveBildRechts = self.bildRechts
        self.saveBildLinks = self.bildLinks

        self.zeitSpring = zeitMonster

    def reset(self):
        self.x = self.xReset
        self.y = self.yReset
        self.leben = True
        self.heldTot = False

    def faehigkeit(self):                        #Fähigkeiten von Monstern werden mit den Fähigkeiten der Klasse überschrieben!!!
        self.toeten()
        self.duplizieren(Geist)

    def duplizieren(self, typ = None):           #einer der Geister wird sich verdoppeln, man weiß jedoch nicht, welcher!
        if Monster.lebendeMonster > 0 and time() - Monster.zeitDupl >= 0.75 * Monster.lebendeMonster * 3:                  #Zeit zur Duplizierung wird jedes mal erhöht
            Monster.zeitDupl = time()    
            # man kann die Funktion duplizieren entweder mit oder ohne Parameter aufrufen.
            # Gibt man keinen Parameter an (also wenn nur self.duplizieren() aufgerufen wird), so wird ein einfacher
            # Geist erschaffen.
            # Gibt man jedoch einen Parameter an, bspw. self.duplizieren(Harpyie) , dann wird entsprechend eine Harpyie erzeugt, mit ihren speziellen Fähigkeiten
            # Vergleiche mit Zeile 50!
            if typ == None:    
                typ = Geist                                                                                                    #Zeit wird wieder auf Null gesetzt
            typ(x = self.x, y = self.y, geschw = self.geschw, breite = self.breite, hoehe = self.hoehe, level = self.level, bildFigur = self.bildFigur, zeitMonster = time()) #Monster wird erschaffen


