# (c) Hochschule Anhalt, veröffentlicht unter MIT-Lizenz
# Magie-Klasse
# Autor: Johannes Tümler
# Letzte Änderung: 12.08.2022
# Zweck: Magie ist das, mit dem der Held schießt (blau) oder der Boss schießt (rosa). Magie fliegt herum.


# Der Nachfolgende Codeblock "BLOCK1" sorgt dafür, dass man aus jeder Datei heraus das Hauptprogramm starten kann.
# Dadurch kann man in jeder Datei auf "play" drücken und es wird automatisch main.py gestartet.
if __name__=="__main__":
    import subprocess
    # Auf Linux oder Mac aktivieren Sie die folgende Zeile und deaktivieren Sie die Zeile danach:
    #subprocess.call("python3 main.py", shell=True)  # die richtige Main-Datei aufrufen (unser eigentliches Hauptprogramm)
    subprocess.call("main.py", shell=True)  # die richtige Main-Datei aufrufen (unser eigentliches Hauptprogramm)
    exit(0) # nun das Programm hier beenden .. wir wollen ja nur das Hauptprogramm starten und nicht *diese* Datei.
    # Hinweis fürs Debugging: Das VSCode-Debugging funktioniert jedoch nur, wenn man das Debugging in der "main.py" beginnt! D.h. wer debuggen möchte, muss die main.py öffnen und dort Debug starten.
# Ende "BLOCK1"

import pygame
from screen import screen
from time import time
from KlasseLevelmanagement import LevelManagement
from KlasseWaffe import Waffe
import sounds

class Magie(Waffe):
    def __init__(self, x, y, richtung, farbe, geschw):
        super().__init__(x, y, richtung, geschw)
        sounds.soundMagie()                                                             #Sound beim Erschaffen von Magie
        self.bildWaffe = [pygame.image.load(f"Bilder/Magie/{farbe}1.png"),
                          pygame.image.load(f"Bilder/Magie/{farbe}2.png"),
                          pygame.image.load(f"Bilder/Magie/{farbe}3.png"),
                          pygame.image.load(f"Bilder/Magie/{farbe}2.png")]
