# (c) Hochschule Anhalt, veröffentlicht unter MIT-Lizenz
# Level1
# Autor: Viktor Lysow, Johannes Tümler
# Letzte Änderung: 22.04.2022
# Zweck: Organisation und Steuerung des ersten Levels

# Der Nachfolgende Codeblock "BLOCK1" sorgt dafür, dass man aus jeder Datei heraus das Hauptprogramm starten kann.
# Dadurch kann man in jeder Datei auf "play" drücken und es wird automatisch main.py gestartet.
if __name__=="__main__":
    import subprocess
    # Auf Linux oder Mac aktivieren Sie die folgende Zeile und deaktivieren Sie die Zeile danach:
    #subprocess.call("python3 main.py", shell=True)  # die richtige Main-Datei aufrufen (unser eigentliches Hauptprogramm)
    subprocess.call("main.py", shell=True)  # die richtige Main-Datei aufrufen (unser eigentliches Hauptprogramm)
    exit(0) # nun das Programm hier beenden .. wir wollen ja nur das Hauptprogramm starten und nicht *diese* Datei.
    # Hinweis fürs Debugging: Das VSCode-Debugging funktioniert jedoch nur, wenn man das Debugging in der "main.py" beginnt! D.h. wer debuggen möchte, muss die main.py öffnen und dort Debug starten.
# Ende "BLOCK1"

from KlasseLevelmanagement import LevelManagement
import pygame
import sounds
import DatenSammeln as ds                           # Für den Matlab Beleg
from screen import screen
from screen import feld
from screen import feldHalbe
from screen import myfont
from time import time
from KlasseMonster import Monster
from KlasseGeist import Geist

zeitStart = True
hintergrundLevel1 = pygame.image.load("Bilder/Karte/Level1.png")
tor = pygame.Rect(3*feld,0,48,48)                                      #Ziel in Level 1

def Level1(spieler):
    global zeitStart

    # display text
    screen.blit(hintergrundLevel1, (0, 0))
    
    def resetLvl1():
        global zeitStart
        ds.daten_csv(8,len(Monster.monsterListe))                          #Level1 Moster Anzahl (für Matlab)
        Monster.monsterListe = []
        Monster.lebendeMonster = 0
        Monster.zeitDupl = time()            
        zeitStart = True


    if len(Monster.monsterListe) == 0 : # falls bereits alle Monster getötet wurden, erstellen wir ein neues Monster für den Neustart des Levels
        # hier darf nicht (if Monster.lebendeMonster == 0) verwendet werden, weil diese Zahl nicht die bereits getöteten beinhaltet
        Geist(x = 100, y = 200, geschw= 3, breite = feld, hoehe = feld, level = LevelManagement.Level,bildFigur= "Geist",zeitMonster= time())


    if LevelManagement.debug:        
        pygame.draw.rect(screen, (0,255,0), (spieler.x,spieler.y, spieler.breite,spieler.hoehe),0)  # Spieler
        pygame.draw.rect(screen, (255,255,0), (3*feld,0,48,48),0) # Tor

        oben = (spieler.x + spieler.breite / 2 - 2, spieler.y, 4, 4)
        unten = (spieler.x + spieler.breite / 2 - 2, spieler.y + spieler.hoehe - 4, 4, 4)
        rechts = (spieler.x + spieler.breite - 2, spieler.y + spieler.hoehe / 2 - 2, 4, 4)
        links = (spieler.x, spieler.y + spieler.hoehe / 2 - 2, 4, 4)

        pygame.draw.rect(screen,(255,0,0), oben)
        pygame.draw.rect(screen,(0,0,255), unten)
        pygame.draw.rect(screen,(255,255,0), rechts)
        pygame.draw.rect(screen,(0,0,128), links)

    if LevelManagement.numFrames >= LevelManagement.fpsTarget:
        LevelManagement.fpsCurrent = (LevelManagement.timeNeeded / LevelManagement.numFrames)
        LevelManagement.numFrames = 0
        LevelManagement.timeNeeded = 0
    textsurface = myfont.render("%i fps" % (1000/LevelManagement.fpsCurrent), False, (255, 255, 0))
    screen.blit(textsurface,(10,0))	

    if zeitStart:                    #Zeit wird ab den ersten aufruf gemäßen (für Matlab)
        zeitStart = False

    for dupli in Monster.monsterListe:                                                            #Alle erschaffenen Monster in Bewegung bringen            
        if LevelManagement.debug:        
            pygame.draw.rect(screen, (255,0,0), (dupli.x,dupli.y,dupli.breite,dupli.hoehe),0)
            pygame.draw.circle(surface = screen, color = (255,0,0), center = (dupli.x + feldHalbe,dupli.y + feldHalbe), radius = Monster.angriffsradius, width = 2)  # die Koordinate der Figur bezieht sich auf "Ecke oben links" des Figur-Icons, daher müssen wir ein halbes Feld dazu rechnen

            pygame.draw.rect(screen,(128,255,0), (dupli.x + dupli.breite / 2 - 2, dupli.y, 4, 4))
            pygame.draw.rect(screen,(128,255,0), (dupli.x + dupli.breite / 2 - 2, dupli.y + dupli.hoehe - 4, 4, 4))
            pygame.draw.rect(screen,(128,255,0), (dupli.x + dupli.breite - 2, dupli.y + dupli.hoehe / 2 - 2, 4, 4))
            pygame.draw.rect(screen,(128,255,0), (dupli.x, dupli.y + dupli.hoehe / 2 - 2, 4, 4))

        if dupli.mlaufen(spieler):           #mit mlaufen läuft der Geist und es wird überprüft, ob der Held getötet wurde
            pygame.display.update()
            pygame.time.wait(1000)
            gameOver = 3
            #monster.reset()                                               #Es wird Alles für den Geist zurück gesetzt
                        # ich muss kein monster.reset machen, weil ich einfach alle Monster lösche. Damit müssen sie sowieso neu erstellt werden
            resetLvl1()                                     
            ds.daten_csv(11,1)          #Nehmendas letzte Level des Spiels auf
            return gameOver
    
    if spieler.obenKollision.colliderect(tor):                        #Held muss mit dem Kopf den Eingang berühren
        LevelManagement.Level += 1
        spieler.neu_Position(582, 476, LevelManagement.Level)                         #Neue Position für das nächste Level
        sounds.soundTor()
        pygame.time.wait(500)
        #monster.reset()                                               #Es wird Alles für den Geist zurück gesetzt
                    # ich muss kein monster.reset machen, weil ich einfach alle Monster lösche. Damit müssen sie sowieso neu erstellt werden
        resetLvl1()
        #ds.daten_csv(8, round(time() - zeit))                          #Zeit für Level1 (für Matlab)
        return LevelManagement.Level 
    else:                                                              #Das Level läuft weiter
        spieler.steuerung()
        return LevelManagement.Level



