# (c) Hochschule Anhalt, veröffentlicht unter MIT-Lizenz
# Hauptprogramm
# Autor: Viktor Lysow, Johannes Tümler
# Letzte Änderung: 14.03.2024
# Zweck: Das ist sozusagen Level 0 - der Startbildschirm


# Der Nachfolgende Codeblock "BLOCK1" sorgt dafür, dass man aus jeder Datei heraus das Hauptprogramm starten kann.
# Dadurch kann man in jeder Datei auf "play" drücken und es wird automatisch main.py gestartet.
if __name__=="__main__":
    import subprocess
    # Auf Linux oder Mac aktivieren Sie die folgende Zeile und deaktivieren Sie die Zeile danach:
    #subprocess.call("python3 main.py", shell=True)  # die richtige Main-Datei aufrufen (unser eigentliches Hauptprogramm)
    subprocess.call("main.py", shell=True)  # die richtige Main-Datei aufrufen (unser eigentliches Hauptprogramm)
    exit(0) # nun das Programm hier beenden .. wir wollen ja nur das Hauptprogramm starten und nicht *diese* Datei.
    # Hinweis fürs Debugging: Das VSCode-Debugging funktioniert jedoch nur, wenn man das Debugging in der "main.py" beginnt! D.h. wer debuggen möchte, muss die main.py öffnen und dort Debug starten.
# Ende "BLOCK1"

import pygame
from screen import screen
from screen import myfont
import button
from hindernisse import feld
from screen import font

hintergrundstart1 = pygame.image.load("Bilder/Start/Start1.png")

x_Mitte = 348

y_NeuesSpiel = 250
y_Ende = 400

gruenDunkel = (0, 150, 0)
gruenHell = (0, 255, 0)

rotDunkel = (150, 0, 0)
rotHell = (255, 0, 0)

blauHell = (0, 0, 255)
grau = (76, 76, 76)

breite = 120
hoehe = 60

randDicke = 1

def start():                                                                    #Startbildschrim
    screen.blit(hintergrundstart1, (0, 0))

    maus = pygame.mouse.get_pos()
    klick = pygame.mouse.get_pressed()

    # Buttons zum Starten / Beenden des Spiels
    neuesSpiel = button.button(x_Mitte, y_NeuesSpiel, "Neues Spiel", breite, hoehe, gruenDunkel, gruenHell, randDicke, maus, klick)      #Neues Spiel hat einen Returnwert
    button.button(x_Mitte, y_Ende, "Ende", breite, hoehe, rotDunkel, rotHell, randDicke, maus, klick)                                 #Ende hat keinen Returnwert

    # Buttons zur Auswahl der Spielpersonen
    wer1 = myfont.render("Choose your destiny", True, (128, 128, 128))
    screen.blit(wer1, (50, 30))
    button.bildButton(f"Bilder/Held/VornS.png", 40, 100, "Held", feld*2, feld*2, grau, blauHell, maus, klick)
    button.bildButton(f"Bilder/Heldin/VornS.png", 40, 100 + (feld + 5)*2, "Heldin", feld*2, feld*2, grau, blauHell, maus, klick)
    button.bildButton(f"Bilder/Boss/VornS.png", 40, 100 + (feld + 5)*4, "Boss", feld*2, feld*2, grau, blauHell, maus, klick)
        
    if neuesSpiel:
        del maus
        del klick
    return neuesSpiel